/*  shogiopening
 *  Copyright (C) 2000 Sverre Hvammen Johansen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

extern void hash_number_init(void);
extern void hash_number_final(void);
extern t_node *new_node_by_number(t_graph *g, int number, char *note);
extern t_node *find_node_by_number(int number);

extern t_graph *check_duplicate_nodes (t_graph *g);
extern void delete_node_in_hash_table(t_node *n);

/* NB: The nodes are inserted without copying */
extern t_node *insert_nodes_in_hash_table(t_graph *g, t_node *n);

/* If an equal node does not exist, a copy of the node is created */
extern t_node *find_node_in_hash_table(t_graph *g, 
#ifdef COMPRESS_BOARD
				       int cboard[9], 
#else
				       char board[10][11], 
#endif
				       char *note);

extern void hash_string_init(void);
extern void hash_string_final(void);

/* If the string is not found, create it */
extern char *find_string_in_hash_table(char *s);
