/*  shogiopening
 *  Copyright (C) 2000 Sverre Hvammen Johansen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include "graph.h"
#include "interface.h"
#include "support.h"
#include "draw.h"
#include "hash.h"
#include "fileio.h"
#include "note.h"
#include "callbacks.h"
#include "preferences.h"

/* Remove the following two functions
   if support for sound is added */

/* Initialize esd connection */
void gnome_sound_init(const char *hostname)
{}
 
/* Closes esd connection */
void gnome_sound_shutdown(void)
{} 

int
main (int argc, char *argv[])
{

#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  gnome_init ("shogiopening", VERSION, argc, argv);

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */

  app1 = create_app1 ();
  
  init_draw();

  gtk_widget_show (app1);

#if 0
  add_pixmap_directory(PIXMAP_DIRECTORY);
  add_pixmap_directory("./pixmaps");
#endif

  init_file();

  note = create_note ();

  preferences_init();

  prunefactor= create_prunefactor ();

  hash_string_init();

  main_graph= 
    open_file_name(NULL,   gtk_entry_get_text
		   (GTK_ENTRY(lookup_widget (preferences, 
					     "combo_entry_default_database"))),
		   FALSE);
  gtk_main ();
  return 0;
}

