/*  shogiopening
 *  Copyright (C) 2000 Sverre Hvammen Johansen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* PATH */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <glib.h>
#include "graph.h"
#include "path.h"

static int longest_path_rek(t_node *n)
{
  GSList *l;
  t_node *n2;
  int max=0, m;
  if (n->mark==0)
    {
      n->mark= 1;
      for (l=n->tos; l!=NULL; l=l->next)
	{
	  m= longest_path_rek(n2=((t_arc *)l->data)->to_node);
	  if (m>max) 
	    {
	      n->next=n2;
	      max=m;
	    }
	}      
      n->mark= max+1;
    }
  return (n->mark);
}

void longest_path (t_node *n)
{
  if (n)
    {
      longest_path_rek(n);
      mark_nodes (n, 0);
    }
}

static int longest_branch_rek(t_node *n)
{
  GSList *l;
  t_node *n2;
  int max=1, m, a=0;
  if (n->mark==0)
    {
      n->mark= 2;
      for (l=n->tos; l!=NULL; l=l->next)
	{
	  m= longest_branch_rek(n2=((t_arc *)l->data)->to_node);
	  if (m!=2) a++;
	  if (m>max) 
	    {
	      n->next=n2;
	      max=m;
	    }
	}
      if (max>2) max++;
      if (max<=2 && a>1) max= 3;
      n->mark= max;
    }
  return (n->mark);
}

void longest_branch (t_node *n)
{
  if (n)
    {
      longest_branch_rek(n);
      mark_nodes (n, 0);
    }
}

static int ordinary_path_rek(t_node *n)
{
  GSList *l;
  t_node *n2;
  int sum=0, max=0, m;
  if (n->mark==0)
    {
      n->mark= 1;
      for (l=n->tos; l!=NULL; l=l->next)
	{
	  sum+= (m=ordinary_path_rek(n2=((t_arc *)l->data)->to_node));
	  if (m>max)
	    {
	      max= m;
	      n->next= n2;
	    }
	}
      if (sum==0) sum=1;
      n->mark= sum;
    }
  return (n->mark);
}

void ordinary_path (t_node *n)
{
  if (n)
    {
      ordinary_path_rek(n);
      mark_nodes (n, 0);
    }
}

